:- use_module(counter).

count_to(1000000).

bench_assert(X) :-
    assert(count(0)),
    bench_assert_aux(X).
bench_assert_aux(X) :-
    retract(count(C)),
    C < X, NC is C + 1,
    assert(count(NC)),
    bench_assert_aux(X).
bench_assert_aux(_).

bench_c(X) :-
    new_counter('my_counter'),
    bench_c_aux('my_counter',X).
bench_c_aux('my_counter',X) :-
    inc_counter('my_counter',C),
    C < X,
    bench_c_aux('my_counter',X).
bench_c_aux(_,_).


bench :-
    counter_init,
    count_to(X),
    statistics(walltime,_),
    bench_assert(X),
    statistics(walltime,[_,TimeA]),
    bench_c(X),
    statistics(walltime,[_,TimeC]),
    format('Counting to: ~w.~nAssert/Retract: ~w~nC-Based: ~w~n', [X,TimeA,TimeC]).
    