#!/bin/sh

# abort execution on any error
set -e

ZIPNAME=windowslib
CROSSCOMPILE_MODULES="counter ltlc myheap nauty probhash random_permutations user_signal"
MSRT32URL="http://www.stups.uni-duesseldorf.de/ProB/buildlibs/msrt120.zip"
MSRT64URL="http://www.stups.uni-duesseldorf.de/ProB/buildlibs/msrt120_64.zip"

for bits in 32 64; do
	if [ $bits -eq 64 ]; then
		SICSTUSDIR="/usr/local/sicstus4.3.0.win64crosscompile"
	fi

	zipdir="$ZIPNAME$bits"
    zipfile="$zipdir.zip"
	libdir="$zipdir/lib"
	rm -rf "$zipdir" "$zipfile"
	mkdir -p "$libdir"

	# Win32 Microsoft C Runtime
    if [ $bits -eq 32 ]; then
        curl "$MSRT32URL" -o msrt32.zip
        unzip -o -j msrt32.zip -d $zipdir
    fi
	# Win64 Microsoft C Runtime
	if [ $bits -eq 64 ]; then
		curl "$MSRT64URL" -o msrt64.zip
		unzip -o -j msrt64.zip -d $zipdir
	fi

	for module in $CROSSCOMPILE_MODULES; do
	    make TARGET_BITS=$bits target_dir=../$libdir -C $module clean crosscompile
	done
    #(cd $zipdir && zip -r ../$zipfile lib Microsoft* )
    (cd $zipdir && zip -r ../$zipfile lib msvc*.dll )
done
