#ifndef LTLBITOPERATIONS_H
#define LTLBITOPERATIONS_H

#include <stdlib.h>
#include <stdio.h>

typedef unsigned int bitfield;

void bitoperations_init(void);
void bitoperations_delete();
size_t get_bitfield_memsize(unsigned int size);
int getbit(const bitfield *b, int pos);
void setbit(bitfield *b, int pos, int value);
void clear_bitfield(bitfield *b, unsigned int size);
void show_bitfield(const bitfield *b, unsigned int size);
void fshow_bitfield(FILE *stream, const bitfield *b, unsigned int offset, unsigned int size);
void setbit_by_long(bitfield *b, int pos, unsigned long value, int size);
void copy_bitfield(const bitfield *src, bitfield *dst, int offset, int size);
void insert_bitfield(const bitfield *src, bitfield *dst, int offset, int size);
void clone_bitfield(const bitfield *src, bitfield *dst, unsigned int size);
int equal_bitfields(const bitfield *a, const bitfield *b, unsigned int size);
int is_null_bitfield(const bitfield *b, unsigned int size);
int is_sub_bitfield(const bitfield *sub, const bitfield *super, unsigned int size);
void add_set_bits(const bitfield *src, bitfield *dst, unsigned int size);

#endif
