#    Title: A Profiler for SICStus Prolog
#    Author: Philip Höfges
#    Heinrich-Heine-University Düsseldorf
#    Lehrstuhl für Softwaretechnik und Programmiersprachen
#    Prof. Dr. Michael Leuschel, Sebastian Krings

# here are all the bottons, labels and so on to create the window
frame .frame
pack .frame

# canvas for names of prediactes
canvas .predicates -background white
pack .predicates -in .frame -side left -anchor n -fill y

# canvas for bars
canvas .result -background black
pack .result -in .frame -side left -anchor n -fill y

# canves for buttons and radiobuttons
canvas .buttons

# label and radiobuttons for case
global c
label .case -text "Choose case" -anchor w
radiobutton .total -value total -text "Total" -variable c -anchor w
radiobutton .entry_success -value entry_success -text "Entry to Success" -variable c -anchor w
radiobutton .entry_fail -value entry_fail -text "Entry to Fail" -variable c -anchor w
radiobutton .redo_success -value redo_success -text "Redo to Success" -variable c -anchor w
radiobutton .redo_fail -value redo_fail -text "Redo to Fail" -variable c -anchor w
pack .case .total .entry_success .entry_fail .redo_success .redo_fail -in .buttons -side top -anchor s -fill both -pady 10

# label and radiobuttons for information
global i
label .info -text "Choose information" -anchor w
radiobutton .calls -value calls -text "Number of calls" -variable i -anchor w
radiobutton .sum -value sum -text "Sum of times" -variable i -anchor w
radiobutton .average -value average -text "Average of times" -variable i -anchor w
radiobutton .min -value min -text "Minimum of times" -variable i -anchor w
radiobutton .max -value max -text "Maximum of times" -variable i -anchor w
pack .info .calls .sum .average .min .max -in .buttons -side top -anchor n -fill both -pady 10

# button to update above choice
button .start -text "Update" -command {prolog profiler:go}
pack .start -in .buttons -anchor w -fill both -pady 10
pack .buttons -in .frame -anchor n -side right

# get the case to calculate value
proc get_case { } {
    global c
    switch -glob $c {
        total { return 0 }
        entry_success { return 1 }
        entry_fail { return 2 }
        redo_success { return 3 }
        redo_fail { return 4 }
    }
}

# get info to calculate value
proc get_info { } {
    global i
    switch -glob $i {
        calls { return 0 }
        sum { return 1 }
        average { return 2 }
        min { return 3 }
        max { return 4 }
    }
}

listbox .l
pack .l -in .predicates

# delete list and rectangles
proc delete { } {
    set len [.l size]
    for {set j 0} {$j<$len} {incr j 1} {
        .l delete end
    }
    .result create rectangle 0 0 99999 99999 -fill black -outline black
}

# set the information into listbox
proc set_information { name } {
    .l insert 0 $name
}

# draw a rectangle
proc draw_rectangle { a b x y } {
    .result create rectangle $a $b $x $y -fill red -outline red
}
