#ifndef HASHTRIE_H_INCLUDED
#define HASHTRIE_H_INCLUDED

#include <stdint.h>

typedef struct node {
    unsigned int ptrs[32];
    uint32_t is_digest;
} tNode;

typedef struct digestblock {
    char *digests;
    struct digestblock *next;
} digestBlock;

void print_readable_digest(unsigned char *key, char *dest);
int calculate_pos(char *key, int depth);
int is_digest(tNode *node, int pos);
unsigned int skip_first_layer(char key[20], int *index);
int trie_get_checked_states_count(void);
int trie_count_elements(void);
char *trie_iterate(unsigned int *blocklen);
int get_max_depth(void);
int teardown_hashtrie(void);
void trie_put(char digest[21]);
void trie_put_checked(char digest[20]);
void trie_put_unchecked(char digest[20]);
int trie_contains(char key[20]);
int trie_contains_processed(char key[20]);

#endif
