#ifndef RING_H_INCLUDED
#define RING_H_INCLUDED

#include "mapper.h"

typedef struct ring_env {
    mmap_env *mmap_env;
    size_t bufsize;

    size_t pos_read;
    size_t pos_write;
    int extending;

    int retrieve_count;
    int put_count;
    int free_count;
} ring_env;

#include "queue.h"

ring_env *ring_init(size_t bufsize);
size_t ring_put(ring_env *env, char *term, size_t len, char *digest);
char *ring_retrieve(ring_env *env, size_t pos, size_t len, char *digest);
void ring_free(ring_env *env, tCell *cell);
void ring_teardown(ring_env *env);

#endif
