#include <assert.h>
#include <stdlib.h>

#include "../../../include/zmq.h"
#include "../../../include/czmq.h"

#include "../../../common/memusage.h"

#include "mctrl.h"
#include "mprint.h"

static void *send_ctrl;
static void *local_printer;

void init_send_ctrl(zctx_t *ctx, int port_start) {
    local_printer = zsocket_new(ctx, ZMQ_PUSH);
    zsocket_connect(local_printer, "inproc://printer");
    DEBUG_PRINT(DEBUG_VERY_VERBOSE,,,":enter :init_send_ctrl");
    assert(send_ctrl == NULL);
    send_ctrl = zsocket_new (ctx, ZMQ_PUB);
    zsocket_bind (send_ctrl, "tcp://*:%d", port_start + 7);
    DEBUG_PRINT(DEBUG_VERY_VERBOSE,,,":exit :init_send_ctrl");
}

void teardown_send_ctrl(zctx_t *ctx) {
    DEBUG_PRINT(DEBUG_VERY_VERBOSE,,,":enter :teardown_send_ctrl");
    assert(send_ctrl != NULL);
    zsocket_destroy(ctx, send_ctrl);
    send_ctrl = NULL;
    DEBUG_PRINT(DEBUG_VERY_VERBOSE,,,":exit :teardown_send_ctrl");
    zsocket_disconnect(local_printer, "inproc://printer");
    zsocket_destroy(ctx, local_printer);
}

void send_term(void) {
    DEBUG_PRINT(DEBUG_VERY_VERBOSE,,,":enter :send_term");
    zstr_send(send_ctrl, "TERM");
    DEBUG_PRINT(DEBUG_VERY_VERBOSE,,,":exit :send_term");
}

void ctrl_memusage() {
    zstr_send(send_ctrl, "MEMORY");
    long x = memory_usage_in_kb();
    DEBUG_PRINT(DEBUG_NORMAL,,,":memory %ld", x);
}
