#include <stdlib.h>
#include <stdint.h>
#include <stdio.h>
#include <string.h>
#include "CuTest.h"
#include "../common/mmap.h"

void TestMmap(CuTest *tc) {
    mmap_init();
    char *a = "foo";
    long int x = mmap_put(a, strlen(a)+1);

    int largeblock = 40000000;
    char *c = (char*) malloc(largeblock);
    CuAssertPtrNotNull(tc, c);

    int i;
    for (i = 0; i < largeblock; i++) {
        c[i] = (char) (rand());
    }

    char *b = "bar";
    long int y = mmap_put(b, strlen(b)+1);

    long int z = mmap_put(c, largeblock);

    char *outa = mmap_get(x, strlen(a) + 1);
    char *outb = mmap_get(y, strlen(b) + 1);
    char *outc = mmap_get(z, largeblock);

    CuAssertStrEquals(tc, outa, a);
    CuAssertStrEquals(tc, outb, b);

    CuAssertMemEquals(tc, outc, c, largeblock);

    free(outa);
    free(outb);
    free(outc);
    free(c);
}

