#include <stdlib.h>
#include <assert.h>
#include <pthread.h>
#include <unistd.h>

#include "wbeat.h"


volatile static int master_alive = 5;
static pthread_mutex_t beat_lock;


static pthread_t ecg;

static void *check_heartbeat(void *arg);

void init_wbeat(void) {
    int rc = pthread_mutex_init(&beat_lock, NULL);
    assert(rc == 0);
    pthread_create(&ecg, NULL, check_heartbeat, NULL);
}

void teardown_wbeat(void) {
    pthread_cancel(ecg);
    pthread_mutex_destroy(&beat_lock);
}

void set_master_alive(void) {
    pthread_mutex_lock(&beat_lock);
    master_alive = 5;
    pthread_mutex_unlock(&beat_lock);
}

static int system_alive(void) {
    pthread_mutex_lock(&beat_lock);
    master_alive--;
    int r = master_alive;
    pthread_mutex_unlock(&beat_lock);
    return r > 0;
}


static void *check_heartbeat(void *arg) {
    while(1) {
        if (system_alive()) {
            sleep(TIMEOUT_CONSTANT);
        } else {
            assert(0);
        }
    }
}
