#ifndef WDEBUG_H_INCLUDED
#define WDEBUG_H_INCLUDED

#include "../../../include/zmq.h"
#include "../../../include/czmq.h"


#define DEBUG_NORMAL 20
#define DEBUG_VERBOSE 19
#define DEBUG_VERY_VERBOSE 5

extern int debug_level;
extern void *debug_printer;
extern char *worker_id;
void init_worker_printer(zctx_t *ctx, int lvl, char *masteraddr, int port, char *id);
void stop_worker_printer(zctx_t *ctx);
void send_text(char *txt, int level);


#define DEBUG_PRINT(Level, Pre, Post, ...) \
    if ((Level) >= debug_level) { \
        Pre \
        struct timeval tmpgt; \
        gettimeofday(&tmpgt, NULL); \
        long int timestamp = ((long int)tmpgt.tv_sec * 1000) + (int)(tmpgt.tv_usec/1000); \
        int __len; \
        __len = snprintf(NULL, 0, __VA_ARGS__); \
        char *buf1 = malloc(__len + 1 + 2); \
        snprintf(buf1, __len + 1, __VA_ARGS__); \
        buf1[__len] = '}'; \
        buf1[__len+1] = '\n'; \
        buf1[__len+2] = 0; \
        int len2; \
        len2 = snprintf(NULL, 0, "{:type :debug :source :worker :id %s :level %d :timestamp %ld ", worker_id, (Level), timestamp); \
        char *buf2 = malloc(len2 + __len + 2 + 1); \
        snprintf(buf2, len2 + 1, "{:type :debug :source :worker :id %s :level %d :timestamp %ld ", worker_id, (Level), timestamp); \
        strcat(buf2, buf1); \
        zstr_send(debug_printer, buf2); \
        free(buf1); \
        free(buf2); \
        Post \
    }


#endif
