:- module(zmq, [init_zmq/0,
                master_main/8, set_fwp/2, set_model/2, set_assertion_mode/1,
                worker_main/5, put_result/1, put_successor/4, shachar/3]).

:- use_module('../../src/module_information.pl').
:- module_info(group,experimental).
:- module_info(description,'This is the interface to C code for distributed model checking.').
:- module_info(revision,'$Rev: 9609 $').
:- module_info(lastchanged,'$LastChangedDate: 2011-11-18 10:43:02 +0100 (Fr, 18 Nov 2011) $').

foreign_resource('zmq', [master_main, set_model, set_fwp, set_assertion_mode,
                         worker_main,put_result, put_successor, shachar]).

% master functions
foreign(master_main, c, master_main(+integer,+integer,+integer,+integer,+integer,+integer,+integer,+string)).
foreign(set_fwp, c, set_fwp(+address(char),+integer)).
foreign(set_model, c, set_model(+address(char),+integer)).
foreign(set_assertion_mode, c, set_assertion_mode(+integer)).

% worker functions
foreign(worker_main, c, worker_main(+string, +integer, +string, +integer, +integer)).
foreign(put_result, put_result(+string)).
foreign(put_successor, put_successor(+address(char),+integer,+address(char),+term)).
foreign(shachar, shachar(+address(char), +integer, [-address(char)])).

:- dynamic is_initialised/0.

init_zmq :- is_initialised,!.
init_zmq :-
    load_foreign_resource(library(zmq)),
    assert(is_initialised).

