/* -*- Mode:C -*-
 *
 * This file is linked and #included into the containing executable (as
 * generated by spld/splfr).
 *
 */

/* [PM] 3.9b5 This file contain templates both for spld generated
   executables (if SPLD_GENERATE_MAIN is true) and templates for
   foreign resource glue code (if SPLD_GENERATE_MAIN is not set).
 */

#if SPLD_GENERATE_MAIN

// NEW function sent by Per Mildner to cure halt/1 bug
static int my_SP_decode_reserved_exception(SP_term_ref tr, long *pdata)
{
 long res = -1;
 long message;
 long data = 0;
 SP_atom tmp_atom;
 int tmp_arity;
 fprintf(stderr, "In my_SP_decode_reserved_exception\n");
 res = 0;                      /* failure */
 if ( SP_get_functor(tr, &tmp_atom, &tmp_arity)
      && tmp_arity == 1
      && tmp_atom == SP_atom_from_string("$reserved")
      )
   {
     SP_term_ref arg1 = SP_new_term_ref();

     if (SP_get_arg(1,tr, arg1) /* decode '$reserved'(X) exception */
         && SP_get_integer(arg1,&message))
       {
         /* xref halt_internal */
         data = (message >> 8);
         res = (message & 0x00FF);
       }
   }

 if (res != 0 && pdata != NULL)
   {
     *pdata = data;
   }
 return res;
}


/* [PM] 4.0 non-negative exception type if a $reserved/1 exception was
   available, *pdata is its attached data or zero (currently only used
   for halt/1.

   return -1 if no proerly formatted $reserved/1 exception was present
*/
static int get_reserved_exception(long *pdata)
{
  long res = -1;
  SP_term_ref exception_term = SP_new_term_ref();

  if (SP_exception_term(exception_term))
    {
      
      long data = 0;

      res = my_SP_decode_reserved_exception(exception_term, &data);  // PATCH 26.8.2008
      if (res > 0)
        {
          *pdata = data;
          return res;
        }
    }
  return -1;
}


/*
  [PM] 3.9b5 Generate main function for spld
  Inputs:
  SPLD_MAIN_NAME -- name of function. A C identifier
  SPLD_DSP -- Development system, 0 (RT) or 1 (DS) (or 2 Extended RT?).
  SPLD_BOOTPATH -- Bootpath, undefined or string literal.
  SPLD_INTERACTIVE -- undefined or 1
  SPLD_USERHOOK -- undefined or 1
  SPLD_LANGUAGE -- 1 for sicstus, 2 for iso
  SPLD_SAV_FILE -- sav file to restore, undefined or string literal.
  SPLD_LOAD_FILES -- files to SP_load, undefined or brace enclosed, 0 terminated list of string literals

  [PM] 4.0 no longer used:
  SPLD_MEMHOOK -- undefined or one of the MM_USE_XXX constants
*/
int SPCDECL SPLD_MAIN_NAME(int argc, char *argv[])
{
  int dsp;
  int rv;
  int sp_argc;
  char **sp_argv;
  SP_pred_ref main_pred;
  int inited=0;                 /* glue_initialize successfully called? */
  int result = 0;

  dsp = (SPLD_DSP);

  SetupSICStusDISPATCH();

#if SPLD_INTERACTIVE
  SP_force_interactive();
#endif /* SPLD_INTERACTIVE */

#if SPLD_USERHOOK
  if (0 != (rv = SU_initialize(argc,argv)))
    {
      result = rv;
      goto cleanup;
    }
#endif /* SPLD_USERHOOK */

  sp_argc = ( argc > 0 ? argc-1 : 0 );
  sp_argv = ( argc > 0 ? argv+1 : argv );

  /* [PM] 4.0.3 Use SP_set_argv to pass argc,argv instead of passing them to sp_glue_initialize */
  rv = sp_glue_initialize(0 /* sp_argc*/, NULL /* sp_argv */,NULL,sp_pre_linkage,sp_pre_map,dsp,SP_GLUE_INITIALIZE_OPTION_RESTORE);

  if (rv != SP_SUCCESS)
    {
      if (SP_errno == 3 /* NOT_FIND_BOOTFILE */)
        {
          fprintf(stderr, "! Prolog engine initialization failed: could not find bootfile %s\n",
                  sp_get_failed_bootpath()); fflush(stderr);
        }
      else if (SP_errno)
        {
          fprintf(stderr, "! Prolog engine initialization failed: %s\n", SP_error_message(SP_errno)); fflush(stderr);
        }
      else
        {
          fprintf(stderr, "! Prolog engine initialization failed\n"); fflush(stderr);
        }
      result=1;
      goto cleanup;
    }
  inited = 1;                   /* need SP_deinitialize */

  if (!SP_set_argv(sp_argc, sp_argv,
#if SP_USER_MAIN_ARGV_UTF8      /* argv is UTF-8, e.g. Windows */
                   SPIO_OPTION_NONE
#else  /* !SP_USER_MAIN_ARGV_UTF8 argv uses some (locale-based) system encoding */
                   SP_SET_ARGV_OPTION_SYSTEM_ENCODING
#endif  /* !SP_SET_ARGV_OPTION_SYSTEM_ENCODING */
                   ))
    {
      fprintf(stderr, "! Prolog engine initialization failed. Malformed or overlong command line.\n"); fflush(stderr);
      result=1;
      goto cleanup;
    }

#ifdef SPLD_LANGUAGE             /* --lang= */
  {
    char *goal;
    SP_pred_ref call_1_pred;
    SP_term_ref goal_term = SP_new_term_ref();
    switch (SPLD_LANGUAGE)
      {
      default:
      case 1:                   /* sicstus */
        goal = "prolog_flag(language,_,sicstus).";
        break;
      case 2:                   /* iso */
        goal = "prolog_flag(language,_,iso).";
        break;
      }
    if (!SP_read_from_string(goal_term, goal, 0))
      {
        fprintf(stderr,"! Could not set language (SP_read_from_string \"%s\").\n", goal); fflush(stderr);
        result=1;
        goto cleanup;
      }
    call_1_pred = SP_predicate("call",1,"user");
    if (!call_1_pred)
      {
        fprintf(stderr,"! Could not find predicate user:call/1.\n"); fflush(stderr);
        result=1;
        goto cleanup;
      }
    rv = SP_query_cut_fail(call_1_pred, goal_term);
    if (rv != SP_SUCCESS)
      {
        fprintf(stderr,"! Could not set language (call(\"%s\")).\n", goal); fflush(stderr);
        result=1;
        goto cleanup;
      }
    SP_reset_term_refs(goal_term);
  }
#endif /* SPLD_LANGUAGE */

#ifdef SPLD_SAV_FILE
  rv = SP_restore(SPLD_SAV_FILE);
  if (rv != SP_SUCCESS)
    {
      /* [PM] 3.12.3 SPRM 8748, detect special exceptions. Important
         if sav-file was created with non-trivial second (predicate-)
         argument to save_program. */
      if (rv == SP_ERROR)
        {
          long data;
          switch (get_reserved_exception(&data))
            {
            case 4:         /* halt/[0,1] */
              result = data;
              goto cleanup;
            case 3:         /* abort/0 (treated like halt(1) */
              result=1;     /* unsuccessful exit (but silent) */
              goto cleanup;
            default:        /* unknown/malformed */
              ;
              /* FALLTHROUGH */
            }
        }
      fprintf(stderr,"! Could not restore \"" SPLD_SAV_FILE "\".\n"); fflush(stderr);
      result=1;
      goto cleanup;
    }
#endif /* SPLD_SAV_FILE */

#ifdef SPLD_LOAD_FILES
  {
    char* load_files[] = SPLD_LOAD_FILES;
    char** pf;
    
    for (pf = &load_files[0]; *pf; pf++)
      {
        /* .pl, .ql, and .po are handled by SP_load() */
        rv = SP_load(*pf);
        if (rv != SP_SUCCESS)
          {
            fprintf(stderr,"! Could not load \"%s\".\n", *pf); fflush(stderr);
            result=1;
            goto cleanup;
          }
      }
  }
#endif /* SPLD_LOAD_FILES */

  main_pred = SP_predicate("main",0,"prolog"); /* known to exist */
  if (main_pred == NULL)
    {
      fprintf(stderr,"! Could not find entrypoint: %s\n",SP_error_message(SP_errno)); fflush(stderr);
      result=1;
      goto cleanup;
    }
  rv = SP_query(main_pred);

  if (rv != SP_SUCCESS)
    {
      /* [PM] 4.0 $reserved/1 exceptions are no longer caught by
         main/0. Handle them here instead (needed for halt/1 argument
         propagation)  */
      if (rv == SP_ERROR)
        {
          long data;
          switch (get_reserved_exception(&data))
            {
            case 4:         /* halt/[0,1] */
              result = data;
              goto cleanup;
            case 3:         /* abort/0 (treated like halt(1) */
              result=1;
              goto cleanup;
            default:        /* unknown/malformed */
              ;
              /* FALLTHROUGH */
            }
        }
      result = 1;
    }

  goto cleanup;

 cleanup:
  if (inited) (void)SP_deinitialize();
  return result;
}


#if !SPLD_USERHOOK /* this is needed for development systems (called by user_main in main.c) */
int SPCDECL SU_initialize(int argc, char *argv[])
{
  (void)argc; (void)argv;
  return 0;
}
#endif /* !SPLD_USERHOOK */


#endif /* SPLD_GENERATE_MAIN */


#if !SPLD_GENERATE_MAIN

#ifndef SP_DYNAMIC_FOREIGN_RESOURCE
#define SP_DYNAMIC_FOREIGN_RESOURCE (SPDLL+0)
#endif

#if (SPDLL || SP_DYNAMIC_FOREIGN_RESOURCE)
#if SP_DYNAMIC_FOREIGN_RESOURCE != SPDLL
#error "C macro inconsistency, SP_DYNAMIC_FOREIGN_RESOURCE should always equal SPDLL"
#endif /* SP_DYNAMIC_FOREIGN_RESOURCE */
#endif /* (SPDLL || SP_DYNAMIC_FOREIGN_RESOURCE) */

#define INCLUDED_IN_FOREIGN_RESOURCE (SP_STATIC_FOREIGN_RESOURCE || SP_DYNAMIC_FOREIGN_RESOURCE)

#define SICSTUS_HIDDEN_API 1
#if LOCAL_INCLUDES
#include "sicstus.h"
#else
#include <sicstus/sicstus.h> /* typedef SICSTUS_DISPATCH_TABLE */
#endif /* LOCAL_INCLUDES */

#ifdef SP_DISPATCH_API          /* [PM] 3.9b5 assumed 1 if undefined in public headers & source */
#if !SP_DISPATCH_API /* 3.9 dispatch-based API */
#error "only SP_DISPATCH_API supported"
#endif /* !SP_DISPATCH_API */
#endif /* SP_DISPATCH_API */

#if !SP_STATIC_FOREIGN_RESOURCE /* if static then instead use main app sp_GlobalSICStus */

#if (MULTI_SP_AWARE && SP_DYNAMIC_FOREIGN_RESOURCE)
/* A multi SP need to pass around the API so should need no global variable for API */
/* nothing */
#else  /* !(MULTI_SP_AWARE && SP_DYNAMIC_FOREIGN_RESOURCE) */
/* This is also the SP_SINGLE_THREADED case */

/* By default what GetSICStusDISPATCH() returns */
SICSTUS_API_STRUCT_TYPE *sp_GlobalSICStus = 0;
#endif /* !(MULTI_SP_AWARE && SP_DYNAMIC_FOREIGN_RESOURCE) */

#endif /* !SP_STATIC_FOREIGN_RESOURCE */

#if INCLUDED_IN_FOREIGN_RESOURCE /* [PM] 3.9b4 rest of file only used when included in foreign resource. */

#if WINCE
static void wince_abort()
{
  exit(3);
}
#define abort wince_abort
#endif /* WINCE */

#if INCLUDED_IN_FOREIGN_RESOURCE

/* [PM] 3.9 These should handle various degrees of MULTI SP awareness in each foreign function stub
            See internals.tex for more info.
*/

#if SP_SINGLE_THREADED
#if DBG

#if __GNUC__
static void *sp_DEBUG_LOCK(char *mutexname, SP_mutex *mutex) __attribute__ ((unused));
#endif /* __GNUC__ */

static void *sp_DEBUG_LOCK(char *mutexname, SP_mutex *mutex)
{
  (void)mutexname;              /* [PM] 3.9b5 avoid -Wunused */
  (void)mutex;                  /* [PM] 3.9b5 avoid -Wunused */

  return 0;
}

#if __GNUC__
static void *sp_DEBUG_UNLOCK(char *mutexname, SP_mutex *mutex) __attribute__ ((unused));
#endif /* __GNUC__ */


static void *sp_DEBUG_UNLOCK(char *mutexname, SP_mutex *mutex)
{
  (void)mutexname;              /* [PM] 3.9b5 avoid -Wunused */
  (void)mutex;                  /* [PM] 3.9b5 avoid -Wunused */

  return 0;
}

#define DEBUG_LOCK_COMMA(MUTEX) sp_DEBUG_LOCK(#MUTEX, &(MUTEX)),
#define DEBUG_UNLOCK_COMMA(MUTEX) sp_DEBUG_UNLOCK(#MUTEX, &(MUTEX)),
#else  /* !DBG */
#define DEBUG_LOCK_COMMA(_MUTEX)
#define DEBUG_UNLOCK_COMMA(_MUTEX)
#endif /* !DBG */

#define SP_MUTEX_LOCK_OTHER(SPAPI,MUTEX) ((DEBUG_LOCK_COMMA(MUTEX)(SPAPI)->dispatch_API_SICSTUS_H->pSP_mutex_lock)(&(MUTEX)))
#define SP_MUTEX_UNLOCK_OTHER(SPAPI,MUTEX) ((DEBUG_UNLOCK_COMMA(MUTEX)(SPAPI)->dispatch_API_SICSTUS_H->pSP_mutex_unlock)(&(MUTEX)))

/* xref flids.c */
#define SP_LOCK_SINGLE_THREADED_RESOURCE(RESNAME,SPAPI) SP_MUTEX_LOCK_OTHER(SPAPI,sp_resource_mutex_ ## RESNAME)
#define SP_UNLOCK_SINGLE_THREADED_RESOURCE(RESNAME,SPAPI) SP_MUTEX_UNLOCK_OTHER(SPAPI,sp_resource_mutex_ ## RESNAME)

#endif /* SP_SINGLE_THREADED */

#if MULTI_SP_AWARE
#if SP_SINGLE_THREADED
#error "MULTI_SP_AWARE and SP_SINGLE_THREADED are incompatible"
#endif /* SP_SINGLE_THREADED */

/* xref flids.c */

#define SP_STUB_LOCAL_DECLARATIONS(_RESNAME) SPAPI_ARG_LOCAL_DECL
#define SP_STUB_SETUP_API(_RESNAME) SPAPI_ARG_NAME = spenv;
#define SP_MAYBE_UNLOCK_SINGLE_THREADED_RESOURCE(_RESNAME)

#else  /* !MULTI_SP_AWARE */

#if SP_STATIC_FOREIGN_RESOURCE
#if SP_SINGLE_THREADED
#error "SP_SINGLE_THREADED is not compatible with SP_STATIC_FOREIGN_RESOURCE"
#endif /* SP_SINGLE_THREADED */
#undef SP_SINGLE_THREADED
#endif /* SP_STATIC_FOREIGN_RESOURCE */

#if SP_SINGLE_THREADED

       /* This foreign code can be used by multiple sicstus run-times
          but only one run-time at a time can be in the foreign
          resource. This is ensured by locking the resource
          mutex. Note that the foreign resource still is responsible
          for maintainging separate state (e.g., static variables) for
          each sicstus run-time.

          Problem is that we need to call SP_mutex_lock in the calling
          SICStus run-time *before* we put the API dispatch into the global
          variable (sp_GlobalSICStus).
       */

#define SP_STUB_LOCAL_DECLARATIONS(_RESNAME)

       /* "Need a proper way to handle deadlock for single threaded foreign resources."
          [PM] 3.9b5 Solved by documenting that the foreign resource
          must ensure that this cannot happen. E.g., by not calling
          any prolog code (SP_query et al). */

#define SP_STUB_SETUP_API(RESNAME)                                                     \
         {                                                                                    \
           SP_LOCK_SINGLE_THREADED_RESOURCE(RESNAME,spenv); /* obtain the mutex lock */       \
           /* Now this thread is the only one in this foreign resource */                     \
           sp_resource_nesting_ ## RESNAME ++;                                                \
           if (sp_resource_nesting_ ## RESNAME == 1) /* first run-time to enter */            \
             {                                                                                \
               (*GetSICStusDISPATCHAddress())=spenv; /* Make sure the SICStus API is available */  \
               SP_CALL_RESOURCE_CONTEXT_SWITCH_HOOK(RESNAME, 1 /* enter */);                  \
             }                                                                                \
             else /* recursive enter, might have changed run-time in the current thread */    \
             {                                                                                \
                if ((*GetSICStusDISPATCHAddress()) != spenv) /* other run-time than before */ \
                   {                                                                                       \
                      /* deadlock! */                                                                      \
                      fprintf(stderr, "\n *** ERROR: deadlock in foreign resource " #RESNAME "\n");        \
                      fprintf(stderr,    "*** ERROR: called from two SICStus run-times in same thread\n"); \
                      fprintf(stderr,    "*** ERROR: aborting.\n");                                        \
                      fflush(stderr);                                                                      \
                      abort();                                                                             \
                   }                                                                          \
             }                                                                                \
         }

#define SP_MAYBE_UNLOCK_SINGLE_THREADED_RESOURCE(RESNAME)                          \
         {                                                                                \
           if (sp_resource_nesting_ ## RESNAME == 1)                                      \
             SP_CALL_RESOURCE_CONTEXT_SWITCH_HOOK(RESNAME, 0 /* exit */);                 \
           sp_resource_nesting_ ## RESNAME --;                                            \
           SP_ZAP_API_GLOBAL_IF_AT_TOPLEVEL(RESNAME);                                     \
           SP_UNLOCK_SINGLE_THREADED_RESOURCE(RESNAME,spenv);                             \
         }

#if SP_NO_CONTEXT_SWITCH_HOOK
#define SP_CALL_RESOURCE_CONTEXT_SWITCH_HOOK(_RESNAME, _ENTER) do{;}while(0)
#else  /* !SP_NO_CONTEXT_SWITCH_HOOK (default) */

#define SP_CALL_RESOURCE_CONTEXT_SWITCH_HOOK(RESNAME, ENTER) \
          SP_CONTEXT_SWITCH_HOOK ((ENTER)) /* SP_CONTEXT_SWITCH_HOOK is #defined in <RESNAME>_glue.h */

#endif /* !SP_NO_CONTEXT_SWITCH_HOOK */


#if DBG
#define SP_ZAP_API_GLOBAL_IF_AT_TOPLEVEL(RESNAME) \
                 if (sp_resource_nesting_ ## RESNAME == 0) { \
                   (*GetSICStusDISPATCHAddress())=NULL; \
                 }
#else  /* !DBG */
#define SP_ZAP_API_GLOBAL_IF_AT_TOPLEVEL(_RESNAME)
#endif /* !DBG */



#else  /* !SP_SINGLE_THREADED */

#define SP_STUB_LOCAL_DECLARATIONS(_RESNAME)
#define SP_STUB_SETUP_API(_RESNAME) /* nothing */
#define SP_MAYBE_UNLOCK_SINGLE_THREADED_RESOURCE(_RESNAME)

#endif /* !SP_SINGLE_THREADED */
#endif /* !MULTI_SP_AWARE */

#endif /* INCLUDED_IN_FOREIGN_RESOURCE */

typedef enum {
  sp_main_no_err=0,
  sp_main_err_param=1,          /* Incorrect parameters (probably called by non-SP_DISPATCH_API run-time) */
  /* Version mismatch between this resource and (calling run-time or calling params) */
  sp_main_version_err=2,
  /* non-MULTI_SP foreign resource invoked from more than once run-time */
  sp_main_err_multiple=3,
  sp_main_err_mutex=4
} sp_main_errcode;


/* foreign resource include this file just before 
   calling sp_main_helper so we can (and must if SP_STATIC_FOREIGN_RESOURCE)
   make it static   */
#if 1                           /* [PM] 4.0 I have removed the extern declaration from spaux.h.in, see if static is OK always. */
static
#else  /* 0 */
#if INCLUDED_IN_FOREIGN_RESOURCE
/* This avoids a (valid) GCC warning about sp_main_helper being declared extern */
#define sp_main_helper sp_main_helper_static
static                          /* <<-- NOTE! */
#endif /* INCLUDED_IN_FOREIGN_RESOURCE */
#endif  /* 0 */
/* the generated sp_main_<RESOURCE> will just call sp_main_helper to do the work */
int SPCDECL sp_main_helper(SP_MAINFUN_PARAMS *params,
                           unsigned long version,
                           SICSTUS_API_STRUCT_TYPE **papi,
                           SP_mutex *mutex,
                           const SP_GlueFunPtr  funcs[],
                           const char* prednames[],
                           const int   arities[],
#if MULTI_SP_AWARE
                           SP_InitFunMulti* init_fun,
                           SP_InitFunMulti* deinit_fun
#else  /* !MULTI_SP_AWARE */
                           SP_InitFunPlain* init_fun,
                           SP_InitFunPlain* deinit_fun
#endif  /* !MULTI_SP_AWARE */
                           )
{
  int err_code = 1;
  static int invocations = 0;
  SICSTUS_API_STRUCT_TYPE *api;
  if (version != SP_MAINFUN_PARAMS_VERSION) { err_code = sp_main_version_err; goto barf; }
  if (params->version != version) { err_code = sp_main_version_err; goto barf; }
  api = params->spenv;

  (void)invocations;            /* [PM] 3.9b5 avoid -Wunused */
  (void)papi;                   /* [PM] 3.9b5 avoid -Wunused */
  (void)mutex;                  /* [PM] 3.9b5 avoid -Wunused */
  (void)api;                    /* [PM] 3.9.1 avoid "set but never used" */

#if SP_SINGLE_THREADED
#error "[PM] 4.0 FIXME: Need to investigate interaction between SP_MANGLE, SP_MAINFUN_PARAM_FLAG_MULTI etc"
#endif  /* SP_SINGLE_THREADED */

  /* Check if more than one SICStus is trying to use this resource */
#if (MULTI_SP_AWARE || SP_SINGLE_THREADED)
  /* nothing, multiple use is OK. */

  params->flags |= SP_MAINFUN_PARAM_FLAG_MULTI;

#else  /* !(MULTI_SP_AWARE || SP_SINGLE_THREADED) */

  params->flags |= SP_MAINFUN_PARAM_FLAG_PLAIN;

#if SP_DYNAMIC_FOREIGN_RESOURCE
  *papi = api; /* must be done even if !SP_MAINFUN_PARAM_FLAG_ENTER so that caller can use SP_XXX on unload too.*/

  {
  /* sharing between multiple sicstus can only happen for shared
     library versions of a foreign resource. */
  if (params->flags & SP_MAINFUN_PARAM_FLAG_ENTER)
    {
      /* The following sets up the SICStus API in a way that would
         work even if MULTI_SP_AWARE had been true (which it is not,
         due to the #if above. The reason for setting things up is to
         give an example for future maintainers. */
      int invocation;
      SPAPI_ARG_PROTO_DECL;        /* needed if MULTI_SP_AWARE */

      /* The following two will write to the same global variable unless
         MULTI_SP_AWARE */
#if DBG
#if MULTI_SP_AWARE
         if (GetSICStusDISPATCHAddress() == papi) /* GetSICStusDISPATCHAddress() should give address of a local variable */
           {
             fprintf(stderr, "\n *** ERROR: invariant error MULTI_SP_AWARE GetSICStusDISPATCHAddress() == papi (%p==%p)\n",
                     GetSICStusDISPATCHAddress(), papi);
             fflush(stderr); abort();
           }
#else/* !MULTI_SP_AWARE */
         if (GetSICStusDISPATCHAddress() != papi) /* both should point at the same global variable */
           {
             fprintf(stderr, "\n *** ERROR: invariant error !MULTI_SP_AWARE GetSICStusDISPATCHAddress() != papi (%p!=%p)\n",
                     GetSICStusDISPATCHAddress(), papi);
             fflush(stderr); abort();
           }
#endif/* !MULTI_SP_AWARE */
#endif  /* DBG */

#if MULTI_SP_AWARE
      (*GetSICStusDISPATCHAddress())=api; /* makes SP_XXX API accessible by setting SPAPI_ARG_PROTO_DECL */
#endif/* MULTI_SP_AWARE */

      if (!SP_mutex_lock(mutex))
        {
#if DBG
          fprintf(stderr, "\n *** ERROR: SP_mutex_lock() error\n"); fflush(stderr); abort();
#endif /* DBG */
          err_code = sp_main_err_mutex;
          goto barf;            /* without attempting to unlock the mutex */
        }
      invocation = ++invocations;
      if (!SP_mutex_unlock(mutex))
        {
#if DBG
          fprintf(stderr, "\n *** ERROR: SP_mutex_unlock() error\n"); fflush(stderr); abort();
#endif /* DBG */
          err_code = sp_main_err_mutex;
          goto barf;
        }

      if (invocation != 1)
        {
#if DBG
          fprintf(stderr, "\nERROR: non-MULTI_SP_AWARE resource loaded multiple times\n");
#endif
          err_code = sp_main_err_multiple;
          goto barf;
        }
    }
  else
    {
       ; /* nothing */
    }
  }
#endif /* SP_DYNAMIC_FOREIGN_RESOURCE */
#endif /* !(MULTI_SP_AWARE || SP_SINGLE_THREADED) */

  params->funcs = funcs;
  params->prednames = prednames;
  params->arities = arities;
#if MULTI_SP_AWARE
  params->init_fun.multi = init_fun;
  params->deinit_fun.multi = deinit_fun;
#else  /* !MULTI_SP_AWARE */
  params->init_fun.plain = init_fun;
  params->deinit_fun.plain = deinit_fun;
#endif  /* !MULTI_SP_AWARE */
  err_code = 0;
 barf:
  return err_code;
}

#endif /* INCLUDED_IN_FOREIGN_RESOURCE */

#endif /* !SPLD_GENERATE_MAIN */
