% (c) 2009-2015 Lehrstuhl fuer Softwaretechnik und Programmiersprachen, 
% Heinrich Heine Universitaet Duesseldorf
% This software is licenced under EPL 1.0 (http://www.eclipse.org/org/documents/epl-v10.html) 

:- module(version, [ version/4,
                     revision/1,
                     lastchangeddate/1
                   ]).

:- use_module(module_information,[module_info/2]).

:- module_info(group,infrastructure).
:- module_info(description,'This module contains the current version number of ProB together with automatically updated version control infos.').


version(1,5,0,'final').

% this file needs to be touched and committed for information below to be updated!

get_revision(R) :- catch(read_revision(R),_,R='no revision found').
get_lastchanged(R) :- catch(read_lastchanged(R),_,R='no lastchanged found').


% Tries to read the revision file generated by make.
% If it does not come from svn, the fallback revision number is used.
read_revision(A) :-
    open('revision', read, ID),
    read_line(ID,R), close(ID),
    atom_codes(A,R).

read_lastchanged(A) :-
    open('lastchanged', read, ID),
    read_line(ID,R), close(ID),
    atom_codes(A,R).

:- dynamic  revision/1, lastchangeddate/1.
:- get_revision(X), assert(revision(X)).
:- get_lastchanged(X), assert(lastchangeddate(X)).
